---
sidebar_position: 3
---

# Agents in BondAI

Agents in BondAI, encompassing both [ConversationalAgent](./conversational-agent.md) and [ReAct Agents](./react-agent.md) both draw inspiration from recent research into LLM/AI Agent architectures. The ConversationalAgent, influenced by the [AutoGen framework](https://arxiv.org/abs/2308.08155), excels in both individual interactions and the development of Multi-Agent Systems (MAS), where multiple agents collaborate to resolve complex tasks. These systems surpass the capabilities of single-agent models in certain classes of problems, offering customizable, conversational, and human-integrated solutions across various fields like coding and decision-making.

ReAct Agents, based on the [ReAct: Synergizing Reasoning and Acting in Language Models](https://arxiv.org/pdf/2210.03629.pdf) paper, integrate reasoning and action in LLMs. This approach allows agents to generate reasoning traces and task-specific actions, enhancing their decision-making abilities. By interfacing with external environments and data sources, ReAct Agents excel in complex problem-solving and reasoning tasks, showcasing significant advancements over traditional methods. Together, these agent types in BondAI showcase a blend of advanced AI interactions, problem-solving prowess, and application versatility.